// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1

package jast.common;

public final class TableCoordinates implements java.lang.Cloneable
{
    public double x;

    public double
    getX()
    {
        return x;
    }

    public void
    setX(double _x)
    {
        x = _x;
    }

    public double y;

    public double
    getY()
    {
        return y;
    }

    public void
    setY(double _y)
    {
        y = _y;
    }

    public double alpha;

    public double
    getAlpha()
    {
        return alpha;
    }

    public void
    setAlpha(double _alpha)
    {
        alpha = _alpha;
    }

    public TableCoordinates()
    {
    }

    public TableCoordinates(double x, double y, double alpha)
    {
        this.x = x;
        this.y = y;
        this.alpha = alpha;
    }

    public boolean
    equals(java.lang.Object rhs)
    {
        if(this == rhs)
        {
            return true;
        }
        TableCoordinates _r = null;
        try
        {
            _r = (TableCoordinates)rhs;
        }
        catch(ClassCastException ex)
        {
        }

        if(_r != null)
        {
            if(x != _r.x)
            {
                return false;
            }
            if(y != _r.y)
            {
                return false;
            }
            if(alpha != _r.alpha)
            {
                return false;
            }

            return true;
        }

        return false;
    }

    public int
    hashCode()
    {
        int __h = 0;
        __h = 5 * __h + (int)java.lang.Double.doubleToLongBits(x);
        __h = 5 * __h + (int)java.lang.Double.doubleToLongBits(y);
        __h = 5 * __h + (int)java.lang.Double.doubleToLongBits(alpha);
        return __h;
    }

    public java.lang.Object
    clone()
    {
        java.lang.Object o = null;
        try
        {
            o = super.clone();
        }
        catch(CloneNotSupportedException ex)
        {
            assert false; // impossible
        }
        return o;
    }

    public void
    __write(IceInternal.BasicStream __os)
    {
        __os.writeDouble(x);
        __os.writeDouble(y);
        __os.writeDouble(alpha);
    }

    public void
    __read(IceInternal.BasicStream __is)
    {
        x = __is.readDouble();
        y = __is.readDouble();
        alpha = __is.readDouble();
    }
}
