// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1

package jast.output;

public final class BodyPrxHelper extends Ice.ObjectPrxHelperBase implements BodyPrx
{
    public void
    close(Hand h)
        throws OperationFailure
    {
        close(h, null, false);
    }

    public void
    close(Hand h, java.util.Map<String, String> __ctx)
        throws OperationFailure
    {
        close(h, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    close(Hand h, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws OperationFailure
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("close");
                __delBase = __getDelegate();
                _BodyDel __del = (_BodyDel)__delBase;
                __del.close(h, __ctx);
                return;
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, __cnt);
            }
        }
    }

    public void
    close_async(AMI_Body_close __cb, Hand h)
    {
        close_async(__cb, h, null, false);
    }

    public void
    close_async(AMI_Body_close __cb, Hand h, java.util.Map<String, String> __ctx)
    {
        close_async(__cb, h, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    close_async(AMI_Body_close __cb, Hand h, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx &&  __ctx == null)
        {
            __ctx = _emptyContext;
        }
        __cb.__invoke(this, __cb, h, __ctx);
    }

    public double
    getGripperWidth(Hand h)
    {
        return getGripperWidth(h, null, false);
    }

    public double
    getGripperWidth(Hand h, java.util.Map<String, String> __ctx)
    {
        return getGripperWidth(h, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private double
    getGripperWidth(Hand h, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("getGripperWidth");
                __delBase = __getDelegate();
                _BodyDel __del = (_BodyDel)__delBase;
                return __del.getGripperWidth(h, __ctx);
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, __cnt);
            }
        }
    }

    public void
    give(Hand h)
        throws OperationFailure
    {
        give(h, null, false);
    }

    public void
    give(Hand h, java.util.Map<String, String> __ctx)
        throws OperationFailure
    {
        give(h, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    give(Hand h, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws OperationFailure
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("give");
                __delBase = __getDelegate();
                _BodyDel __del = (_BodyDel)__delBase;
                __del.give(h, __ctx);
                return;
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, __cnt);
            }
        }
    }

    public void
    give_async(AMI_Body_give __cb, Hand h)
    {
        give_async(__cb, h, null, false);
    }

    public void
    give_async(AMI_Body_give __cb, Hand h, java.util.Map<String, String> __ctx)
    {
        give_async(__cb, h, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    give_async(AMI_Body_give __cb, Hand h, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx &&  __ctx == null)
        {
            __ctx = _emptyContext;
        }
        __cb.__invoke(this, __cb, h, __ctx);
    }

    public void
    insert(Hand h)
        throws OperationFailure
    {
        insert(h, null, false);
    }

    public void
    insert(Hand h, java.util.Map<String, String> __ctx)
        throws OperationFailure
    {
        insert(h, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    insert(Hand h, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws OperationFailure
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("insert");
                __delBase = __getDelegate();
                _BodyDel __del = (_BodyDel)__delBase;
                __del.insert(h, __ctx);
                return;
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, __cnt);
            }
        }
    }

    public void
    insert_async(AMI_Body_insert __cb, Hand h)
    {
        insert_async(__cb, h, null, false);
    }

    public void
    insert_async(AMI_Body_insert __cb, Hand h, java.util.Map<String, String> __ctx)
    {
        insert_async(__cb, h, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    insert_async(AMI_Body_insert __cb, Hand h, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx &&  __ctx == null)
        {
            __ctx = _emptyContext;
        }
        __cb.__invoke(this, __cb, h, __ctx);
    }

    public boolean
    isReachable(Hand h, jast.common.TableCoordinates coords)
    {
        return isReachable(h, coords, null, false);
    }

    public boolean
    isReachable(Hand h, jast.common.TableCoordinates coords, java.util.Map<String, String> __ctx)
    {
        return isReachable(h, coords, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private boolean
    isReachable(Hand h, jast.common.TableCoordinates coords, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("isReachable");
                __delBase = __getDelegate();
                _BodyDel __del = (_BodyDel)__delBase;
                return __del.isReachable(h, coords, __ctx);
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, __cnt);
            }
        }
    }

    public void
    moveaway()
        throws OperationFailure
    {
        moveaway(null, false);
    }

    public void
    moveaway(java.util.Map<String, String> __ctx)
        throws OperationFailure
    {
        moveaway(__ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    moveaway(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws OperationFailure
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("moveaway");
                __delBase = __getDelegate();
                _BodyDel __del = (_BodyDel)__delBase;
                __del.moveaway(__ctx);
                return;
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, __cnt);
            }
        }
    }

    public void
    moveaway_async(AMI_Body_moveaway __cb)
    {
        moveaway_async(__cb, null, false);
    }

    public void
    moveaway_async(AMI_Body_moveaway __cb, java.util.Map<String, String> __ctx)
    {
        moveaway_async(__cb, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    moveaway_async(AMI_Body_moveaway __cb, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx &&  __ctx == null)
        {
            __ctx = _emptyContext;
        }
        __cb.__invoke(this, __cb, __ctx);
    }

    public void
    open(Hand h)
        throws OperationFailure
    {
        open(h, null, false);
    }

    public void
    open(Hand h, java.util.Map<String, String> __ctx)
        throws OperationFailure
    {
        open(h, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    open(Hand h, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws OperationFailure
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("open");
                __delBase = __getDelegate();
                _BodyDel __del = (_BodyDel)__delBase;
                __del.open(h, __ctx);
                return;
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, __cnt);
            }
        }
    }

    public void
    open_async(AMI_Body_open __cb, Hand h)
    {
        open_async(__cb, h, null, false);
    }

    public void
    open_async(AMI_Body_open __cb, Hand h, java.util.Map<String, String> __ctx)
    {
        open_async(__cb, h, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    open_async(AMI_Body_open __cb, Hand h, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx &&  __ctx == null)
        {
            __ctx = _emptyContext;
        }
        __cb.__invoke(this, __cb, h, __ctx);
    }

    public void
    pickUp(Hand h, jast.common.TableCoordinates coords)
        throws OperationFailure
    {
        pickUp(h, coords, null, false);
    }

    public void
    pickUp(Hand h, jast.common.TableCoordinates coords, java.util.Map<String, String> __ctx)
        throws OperationFailure
    {
        pickUp(h, coords, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    pickUp(Hand h, jast.common.TableCoordinates coords, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws OperationFailure
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("pickUp");
                __delBase = __getDelegate();
                _BodyDel __del = (_BodyDel)__delBase;
                __del.pickUp(h, coords, __ctx);
                return;
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, __cnt);
            }
        }
    }

    public void
    pickUp_async(AMI_Body_pickUp __cb, Hand h, jast.common.TableCoordinates coords)
    {
        pickUp_async(__cb, h, coords, null, false);
    }

    public void
    pickUp_async(AMI_Body_pickUp __cb, Hand h, jast.common.TableCoordinates coords, java.util.Map<String, String> __ctx)
    {
        pickUp_async(__cb, h, coords, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    pickUp_async(AMI_Body_pickUp __cb, Hand h, jast.common.TableCoordinates coords, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx &&  __ctx == null)
        {
            __ctx = _emptyContext;
        }
        __cb.__invoke(this, __cb, h, coords, __ctx);
    }

    public void
    point(Hand h, jast.common.TableCoordinates coords)
        throws OperationFailure
    {
        point(h, coords, null, false);
    }

    public void
    point(Hand h, jast.common.TableCoordinates coords, java.util.Map<String, String> __ctx)
        throws OperationFailure
    {
        point(h, coords, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    point(Hand h, jast.common.TableCoordinates coords, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws OperationFailure
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("point");
                __delBase = __getDelegate();
                _BodyDel __del = (_BodyDel)__delBase;
                __del.point(h, coords, __ctx);
                return;
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, __cnt);
            }
        }
    }

    public void
    point_async(AMI_Body_point __cb, Hand h, jast.common.TableCoordinates coords)
    {
        point_async(__cb, h, coords, null, false);
    }

    public void
    point_async(AMI_Body_point __cb, Hand h, jast.common.TableCoordinates coords, java.util.Map<String, String> __ctx)
    {
        point_async(__cb, h, coords, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    point_async(AMI_Body_point __cb, Hand h, jast.common.TableCoordinates coords, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx &&  __ctx == null)
        {
            __ctx = _emptyContext;
        }
        __cb.__invoke(this, __cb, h, coords, __ctx);
    }

    public void
    pointAtWorld(Hand h, jast.common.WorldCoordinates coords)
        throws OperationFailure
    {
        pointAtWorld(h, coords, null, false);
    }

    public void
    pointAtWorld(Hand h, jast.common.WorldCoordinates coords, java.util.Map<String, String> __ctx)
        throws OperationFailure
    {
        pointAtWorld(h, coords, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    pointAtWorld(Hand h, jast.common.WorldCoordinates coords, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws OperationFailure
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("pointAtWorld");
                __delBase = __getDelegate();
                _BodyDel __del = (_BodyDel)__delBase;
                __del.pointAtWorld(h, coords, __ctx);
                return;
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, __cnt);
            }
        }
    }

    public void
    pointAtWorld_async(AMI_Body_pointAtWorld __cb, Hand h, jast.common.WorldCoordinates coords)
    {
        pointAtWorld_async(__cb, h, coords, null, false);
    }

    public void
    pointAtWorld_async(AMI_Body_pointAtWorld __cb, Hand h, jast.common.WorldCoordinates coords, java.util.Map<String, String> __ctx)
    {
        pointAtWorld_async(__cb, h, coords, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    pointAtWorld_async(AMI_Body_pointAtWorld __cb, Hand h, jast.common.WorldCoordinates coords, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx &&  __ctx == null)
        {
            __ctx = _emptyContext;
        }
        __cb.__invoke(this, __cb, h, coords, __ctx);
    }

    public void
    putDown(Hand h, jast.common.TableCoordinates coords)
        throws OperationFailure
    {
        putDown(h, coords, null, false);
    }

    public void
    putDown(Hand h, jast.common.TableCoordinates coords, java.util.Map<String, String> __ctx)
        throws OperationFailure
    {
        putDown(h, coords, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    putDown(Hand h, jast.common.TableCoordinates coords, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws OperationFailure
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("putDown");
                __delBase = __getDelegate();
                _BodyDel __del = (_BodyDel)__delBase;
                __del.putDown(h, coords, __ctx);
                return;
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, __cnt);
            }
        }
    }

    public void
    putDown_async(AMI_Body_putDown __cb, Hand h, jast.common.TableCoordinates coords)
    {
        putDown_async(__cb, h, coords, null, false);
    }

    public void
    putDown_async(AMI_Body_putDown __cb, Hand h, jast.common.TableCoordinates coords, java.util.Map<String, String> __ctx)
    {
        putDown_async(__cb, h, coords, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    putDown_async(AMI_Body_putDown __cb, Hand h, jast.common.TableCoordinates coords, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx &&  __ctx == null)
        {
            __ctx = _emptyContext;
        }
        __cb.__invoke(this, __cb, h, coords, __ctx);
    }

    public void
    screw(Hand h)
        throws OperationFailure
    {
        screw(h, null, false);
    }

    public void
    screw(Hand h, java.util.Map<String, String> __ctx)
        throws OperationFailure
    {
        screw(h, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    screw(Hand h, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws OperationFailure
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("screw");
                __delBase = __getDelegate();
                _BodyDel __del = (_BodyDel)__delBase;
                __del.screw(h, __ctx);
                return;
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, __cnt);
            }
        }
    }

    public void
    screw_async(AMI_Body_screw __cb, Hand h)
    {
        screw_async(__cb, h, null, false);
    }

    public void
    screw_async(AMI_Body_screw __cb, Hand h, java.util.Map<String, String> __ctx)
    {
        screw_async(__cb, h, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    screw_async(AMI_Body_screw __cb, Hand h, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx &&  __ctx == null)
        {
            __ctx = _emptyContext;
        }
        __cb.__invoke(this, __cb, h, __ctx);
    }

    public void
    show(Hand h)
        throws OperationFailure
    {
        show(h, null, false);
    }

    public void
    show(Hand h, java.util.Map<String, String> __ctx)
        throws OperationFailure
    {
        show(h, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    show(Hand h, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws OperationFailure
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("show");
                __delBase = __getDelegate();
                _BodyDel __del = (_BodyDel)__delBase;
                __del.show(h, __ctx);
                return;
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, __cnt);
            }
        }
    }

    public void
    show_async(AMI_Body_show __cb, Hand h)
    {
        show_async(__cb, h, null, false);
    }

    public void
    show_async(AMI_Body_show __cb, Hand h, java.util.Map<String, String> __ctx)
    {
        show_async(__cb, h, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    show_async(AMI_Body_show __cb, Hand h, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx &&  __ctx == null)
        {
            __ctx = _emptyContext;
        }
        __cb.__invoke(this, __cb, h, __ctx);
    }

    public void
    stop()
    {
        stop(null, false);
    }

    public void
    stop(java.util.Map<String, String> __ctx)
    {
        stop(__ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    stop(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __delBase = __getDelegate();
                _BodyDel __del = (_BodyDel)__delBase;
                __del.stop(__ctx);
                return;
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, __cnt);
            }
        }
    }

    public void
    take(Hand h)
        throws OperationFailure
    {
        take(h, null, false);
    }

    public void
    take(Hand h, java.util.Map<String, String> __ctx)
        throws OperationFailure
    {
        take(h, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    take(Hand h, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws OperationFailure
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("take");
                __delBase = __getDelegate();
                _BodyDel __del = (_BodyDel)__delBase;
                __del.take(h, __ctx);
                return;
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, __cnt);
            }
        }
    }

    public void
    take_async(AMI_Body_take __cb, Hand h)
    {
        take_async(__cb, h, null, false);
    }

    public void
    take_async(AMI_Body_take __cb, Hand h, java.util.Map<String, String> __ctx)
    {
        take_async(__cb, h, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    take_async(AMI_Body_take __cb, Hand h, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx &&  __ctx == null)
        {
            __ctx = _emptyContext;
        }
        __cb.__invoke(this, __cb, h, __ctx);
    }

    public static BodyPrx
    checkedCast(Ice.ObjectPrx __obj)
    {
        BodyPrx __d = null;
        if(__obj != null)
        {
            try
            {
                __d = (BodyPrx)__obj;
            }
            catch(ClassCastException ex)
            {
                if(__obj.ice_isA("::jast::output::Body"))
                {
                    BodyPrxHelper __h = new BodyPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static BodyPrx
    checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        BodyPrx __d = null;
        if(__obj != null)
        {
            try
            {
                __d = (BodyPrx)__obj;
            }
            catch(ClassCastException ex)
            {
                if(__obj.ice_isA("::jast::output::Body", __ctx))
                {
                    BodyPrxHelper __h = new BodyPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static BodyPrx
    checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        BodyPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA("::jast::output::Body"))
                {
                    BodyPrxHelper __h = new BodyPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static BodyPrx
    checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        BodyPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA("::jast::output::Body", __ctx))
                {
                    BodyPrxHelper __h = new BodyPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static BodyPrx
    uncheckedCast(Ice.ObjectPrx __obj)
    {
        BodyPrx __d = null;
        if(__obj != null)
        {
            BodyPrxHelper __h = new BodyPrxHelper();
            __h.__copyFrom(__obj);
            __d = __h;
        }
        return __d;
    }

    public static BodyPrx
    uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        BodyPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            BodyPrxHelper __h = new BodyPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    protected Ice._ObjectDelM
    __createDelegateM()
    {
        return new _BodyDelM();
    }

    protected Ice._ObjectDelD
    __createDelegateD()
    {
        return new _BodyDelD();
    }

    public static void
    __write(IceInternal.BasicStream __os, BodyPrx v)
    {
        __os.writeProxy(v);
    }

    public static BodyPrx
    __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            BodyPrxHelper result = new BodyPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }
}
