// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1

package jast.output;

public enum Hand
{
    HandLeft(0),
    HandRight(1),
    HandAny(2);

    private static Hand[] __values = new Hand[3];
    static
    {
        __values[0] = HandLeft;
        __values[1] = HandRight;
        __values[2] = HandAny;
    }
    private int __value;

    public static final int _HandLeft = 0;
    public static final int _HandRight = 1;
    public static final int _HandAny = 2;

    public static Hand
    convert(int val)
    {
        assert val < 3;
        return __values[val];
    }

    public static Hand
    convert(String val)
    {
        for(int __i = 0; __i < __values.length; ++__i)
        {
            if(__values[__i].toString().equals(val))
            {
                return __values[__i];
            }
        }
        assert false;
        return null;
    }

    public int
    value()
    {
        return __value;
    }

    private
    Hand(int val)
    {
        __value = val;
    }

    public void
    __write(IceInternal.BasicStream __os)
    {
        __os.writeByte((byte)__value);
    }

    public static Hand
    __read(IceInternal.BasicStream __is)
    {
        int __v = __is.readByte();
        if(__v < 0 || __v >= 3)
        {
            throw new Ice.MarshalException();
        }
        return Hand.convert(__v);
    }
}
